<template>
  <div class="app-container">
    <div class="search">
      <el-date-picker v-model="table.getdataListParm.parammaps.inputDatetime" class="inputDatetime filter-item" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" style="width: 250px;" />
      <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
      <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
      <el-select v-model="table.getdataListParm.parammaps.times" filterable placeholder="班次" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="item in frequencyList" :key="item.id" :label="item.name" :value="item.id" />
      </el-select>
      <el-select v-model="table.getdataListParm.parammaps.eqclass" placeholder="设备类别" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="item in equipmentCategoryList" :key="item.id" :label="item.name" :value="item.name" />
      </el-select>
      <el-input ref="eqcode" v-model="table.getdataListParm.parammaps.eqcode" class="filter-item" placeholder="设备编号" style="width: 120px;" />
      <el-input ref="driver" v-model="table.getdataListParm.parammaps.driver" class="filter-item" placeholder="驾驶员" style="width: 120px;" />
      <el-button class="successBorder" @click="form_search">查询</el-button>
      <el-button class="successBorder" @click="handleRefresh">重置</el-button>
    </div>
    <div class="operation">
      <el-button v-if="isRoleEdit" class="success" icon="el-icon-plus"  @click="handleCreate">分配</el-button>
      <el-button v-if="isRoleEdit" icon="el-icon-delete" class="danger" @click="form_delete">删除</el-button>
      <el-button class="export" icon="el-icon-upload2" style="float: right;margin-right: 10px;" @click="handleExport">导出</el-button>
    </div>
    <div class="table">
      <el-table
        :key="table.tableKey"
        v-loading="table.listLoading"
        element-loading-text="给我一点时间"
        :data="table.list"
        border
        fit
        highlight-current-row
        style="width: 100%;"
        :row-style="rowStyle"
        :cell-style="cellStyle"
        class="elTable table-fixed"
        @selection-change="handleSelectionChange"
        :max-height="myHeight"
      >
        <el-table-column type="selection" align="center" width="50" />
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="生效日期" min-width="150px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.operatetime }}</span>
          </template>
        </el-table-column>
        <el-table-column label="班次" min-width="150px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.times }}</span>
          </template>
        </el-table-column>
        <el-table-column label="设备类别" min-width="90px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.eqclass }}</span>
          </template>
        </el-table-column>
        <el-table-column label="设备编号" min-width="100px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.eqcode }}</span>
          </template>
        </el-table-column>
        <el-table-column label="驾驶员" min-width="90px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.driver }}</span>
          </template>
        </el-table-column>
        <el-table-column label="分配人" min-width="90px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.emp }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="50" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <el-button v-if="isRoleEdit" class="miniDanger" icon="el-icon-delete" @click="handleRowDelete(row)" />
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>=0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="getList" />
    </div>

    <!-- 新增/编辑 -->
    <el-dialog :fullscreen="dialogFull" :visible.sync="create.dialogFormVisible" :close-on-click-modal="false" width="90%">
      <template slot="title">
        <div class="avue-crud__dialog__header">
          <span class="el-dialog__title">
            <span style="display:inline-block;width:3px;height:20px;margin-right:5px; float: left;margin-top:2px" />
            {{ textMap[create.dialogStatus] }}
          </span>
          <div class="avue-crud__dialog__menu" @click="dialogFull? dialogFull=false: dialogFull=true">
            <svg-icon v-if="dialogFull" icon-class="exit-fullscreen" />
            <svg-icon v-else icon-class="fullscreen" />
          </div>
        </div>
      </template>
      <div class="app-add">
        <el-tabs v-model="create.activeName" @tab-click="handleClick">
          <el-tab-pane label="TMR设备" name="first">
            <div class="TMR">
              <div class="table">
                <el-table
                  :key="create.tableKey"
                  v-loading="create.listLoading"
                  element-loading-text="给我一点时间"
                  :data="create.list"
                  border
                  fit
                  highlight-current-row
                  style="width: 100%;margin-bottom: 50px;"
                  :row-style="rowStyle"
                  :cell-style="cellStyle"
                  class="elTable table-fixed"
                >
                  <el-table-column label="班次" min-width="150px" align="center">
                    <template slot-scope="scope">
                      <span>{{ scope.row.timesstr }}</span>
                    </template>
                  </el-table-column>
                  <el-table-column label="设备类别" min-width="90px" align="center">
                    <template slot-scope="scope">
                      <span>{{ scope.row.eqclass }}</span>
                    </template>
                  </el-table-column>
                  <el-table-column label="设备编号" min-width="100px" align="center">
                    <template slot-scope="scope">
                      <span>{{ scope.row.eqcode }}</span>
                    </template>
                  </el-table-column>
                  <el-table-column label="驾驶员" min-width="90px" align="center">
                    <template slot-scope="scope">
                      <el-select v-model="scope.row.driverid" filterable placeholder="驾驶员" class="filter-item" style="width: 100%;padding: 0 10px;" @change="(value)=> {changeDriver(value, scope.row)}">
                        <el-option v-for="item in driverList" :key="item.id" :label="item.drivername" :value="item.id" />
                      </el-select>
                    </template>
                  </el-table-column>
                  <el-table-column label="生效日期" min-width="90px" align="center">
                    <template slot-scope="scope">
                      <el-date-picker v-model="scope.row.operatetime" type="date" format="yyyy-MM-dd" value-format="yyyy-MM-dd" placeholder="生效日期" :clearable="false" class="filter-item operatetime" style="width: 100%;" @focus="focusOperatetime(scope.row)" @change="changeOperatetime(scope.row)" />
                    </template>
                  </el-table-column>
                </el-table>
              </div>
              <div slot="footer" class="dialog-footer" style="bottom: 20px;">
                <el-button class="cancelClose" @click="create.dialogFormVisible = false;getList()">关闭</el-button>
                <el-button v-if="create.dialogStatus==='create' || create.dialogStatus==='update'" class="save" :disabled="isokDisable" @click="createData()">确认</el-button>
              </div>
            </div>
          </el-tab-pane>
          <el-tab-pane label="铲车" name="second">
            <div class="forklift">
              <div class="table">
                <el-table
                  :key="create.tableKey2"
                  v-loading="create.listLoading2"
                  element-loading-text="给我一点时间"
                  :data="create.list2"
                  border
                  fit
                  highlight-current-row
                  style="width: 100%;margin-bottom: 50px;"
                  :row-style="rowStyle"
                  :cell-style="cellStyle"
                  class="elTable table-fixed"
                >
                  <el-table-column label="班次" min-width="150px" align="center">
                    <template slot-scope="scope">
                      <span>{{ scope.row.timesstr }}</span>
                    </template>
                  </el-table-column>
                  <el-table-column label="设备类别" min-width="90px" align="center">
                    <template slot-scope="scope">
                      <span>{{ scope.row.eqclass }}</span>
                    </template>
                  </el-table-column>
                  <el-table-column label="设备编号" min-width="100px" align="center">
                    <template slot-scope="scope">
                      <span>{{ scope.row.eqcode }}</span>
                    </template>
                  </el-table-column>
                  <el-table-column label="驾驶员" min-width="90px" align="center">
                    <template slot-scope="scope">
                      <el-select v-model="scope.row.driverid" filterable placeholder="驾驶员" class="filter-item" style="width: 100%;padding: 0 10px;" @change="(value)=> {changeDriver(value, scope.row)}">
                        <el-option v-for="item in driverList" :key="item.id" :label="item.drivername" :value="item.id" />
                      </el-select>
                    </template>
                  </el-table-column>
                  <el-table-column label="生效日期" min-width="90px" align="center">
                    <template slot-scope="scope">
                      <el-date-picker v-model="scope.row.operatetime" type="date" format="yyyy-MM-dd" value-format="yyyy-MM-dd" :clearable="false" placeholder="生效日期" class="filter-item operatetime" style="width: 100%;" @focus="focusOperatetime2(scope.row)" @change="changeOperatetime2(scope.row)" />
                    </template>
                  </el-table-column>
                </el-table>
              </div>
              <div slot="footer" class="dialog-footer" style="bottom: 20px;">
                <el-button class="cancelClose" @click="create.dialogFormVisible = false;getList()">关闭</el-button>
                <el-button v-if="create.dialogStatus==='create' || create.dialogStatus==='update'" class="save" :disabled="isokDisable" @click="createData2()">确认</el-button>
              </div>
            </div>
          </el-tab-pane>
        </el-tabs>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { GetDataByName, PostDataByName, ExecDataByConfig, GetDataByNames, checkButtons } from '@/api/common'
import Cookies from 'js-cookie'
import { parseTime, json2excel } from '@/utils/index.js'
import Pagination from '@/components/Pagination'
import { MessageBox } from 'element-ui'
var createList = []
export default {
  name: 'DutyRecord',
  components: { Pagination },
  data() {
    return {
      dialogFull: false,
      isRoleEdit: [],
      requestParams: [
        { name: 'getSysoptEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid'), 'inforname': 'times' }},
        { name: 'getDriverListEnable', offset: 0, pagecount: 0, parammaps: { 'pastureid': Cookies.get('pastureid') }}
      ],
      equipmentCategoryList: [{ id: '1', name: 'TMR设备' }, { id: '2', name: '铲车' }], // 设备类别
      frequencyList: [], // 班次
      driverList: [], // 驾驶员

      table: {
        getdataListParm: {
          name: 'getDutyrecordList',
          page: 1,
          offset: 1,
          pagecount: parseInt(Cookies.get('pageCount')),
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            startTime: '',
            stopTime: '',
            inputDatetime: '',
            times: '',
            eqclass: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,
        temp: {}
      },

      // 新增/编辑
      create: {
        dialogFormVisible: false,
        dialogStatus: '',
        temp: { pastureid: Cookies.get('pastureid'), operatetime: parseTime(new Date(), '{y}-{m}-{d} {h}:{m}'), emp: Cookies.get('employename'), barid: '', barname: '', remain: '', times: '' },
        rules: {},
        tableKey: 0,
        list: [],
        createList: [],
        total: 0,
        listLoading: true,
        getdataListParm: {
          name: 'geEqListByDplan',
          page: 1,
          offset: 1,
          pagecount: '',
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        tableKey2: 0,
        list2: [],
        createList2: [],
        total2: 0,
        listLoading2: true,
        getdataListParm2: {
          name: 'geEqListByDplanCC',
          page: 1,
          offset: 1,
          pagecount: '',
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid')
          }
        },
        activeName: 'first'
      },
      textMap: {
        create: '分配'
      },
      requestParam: {},
      download: {
        getdataListParm: {
          name: 'getDutyrecordList',
          page: 1,
          offset: 1,
          pagecount: 0,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            barid: '',
            startTime: '',
            stopTime: '',
            inputDatetime: '',
            times: '',
            eqclass: ''
          }
        },
        list: []
      },
      isokDisable: false,
      selectList: [],
      rowStyle: { maxHeight: 30 + 'px', height: 30 + 'px' },
      cellStyle: { padding: 0 + 'px' },
      myHeight:document.documentElement.clientHeight - 85- 150 - 45
    }
  },

  created() {
    this.getList()
    this.getDownList()
    this.getButtons()
  },

  methods: {
    getButtons() {
      const Edit = 'DutyRecord'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    getDownList() {
      GetDataByNames(this.requestParams).then(response => {
        if (response.data.getSysoptEnable.list !== null) {
          for (let i = 1; i <= response.data.getSysoptEnable.list[0].inforvalue; i++) {
            const obj = {}
            obj.id = String(i)
            if (i == 1) { obj.name = '第一班' } else if (i == 2) { obj.name = '第二班' } else if (i == 3) { obj.name = '第三班' } else if (i == 4) { obj.name = '第四班' }
            this.frequencyList.push(obj)
          }
        } else {
          this.frequencyList = []
        }
        this.driverList = response.data.getDriverListEnable.list
      })
    },

    handleBefore() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() - 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() - 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() + 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() + 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.$forceUpdate()
      }
    },
    getList() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    form_search() {
      console.log('点击了查询')
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        this.table.getdataListParm.parammaps.startTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.table.getdataListParm.parammaps.inputDatetime = ''
        this.table.getdataListParm.parammaps.startTime = ''
        this.table.getdataListParm.parammaps.stopTime = ''
      }
      this.table.getdataListParm.offset = 1
      this.getList()
    },
    handleRefresh() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.times = ''
      this.table.getdataListParm.parammaps.eqclass = ''
      this.table.getdataListParm.parammaps.eqcode = ''
      this.table.getdataListParm.parammaps.driver = ''
      this.table.getdataListParm.parammaps.startTime = ''
      this.table.getdataListParm.parammaps.stopTime = ''
      this.table.getdataListParm.parammaps.inputDatetime = ''
      this.table.getdataListParm.offset = 1
      this.getList()
    },

    // 新增
    handleCreate() {
      console.log('点击了分配')
      this.create.dialogStatus = 'create'
      this.dialogFull = false
      this.create.dialogFormVisible = true
      this.getDialogList()
    },
    handleClick() {
      if (this.create.activeName == 'first') {
        this.getDialogList()
      } else if (this.create.activeName == 'second') {
        this.getDialogList2()
      }
    },
    getDialogList() {
      GetDataByName(this.create.getdataListParm).then(response => {
        console.log('table数据1', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            if (response.data.list[i].driver == undefined || response.data.list[i].driverid == undefined) {
              this.$set(response.data.list[i], 'driver', '')
              this.$set(response.data.list[i], 'driverid', '')
            }
            this.$set(response.data.list[i], 'sort', 'create' + i)
          }
          this.create.list = response.data.list
        } else {
          this.create.list = []
        }
        setTimeout(() => {
          this.create.listLoading = false
        }, 100)
      })
    },
    getDialogList2() {
      GetDataByName(this.create.getdataListParm2).then(response => {
        console.log('table2数据', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            if (response.data.list[i].driver == undefined || response.data.list[i].driverid == undefined) {
              this.$set(response.data.list[i], 'driver', '')
              this.$set(response.data.list[i], 'driverid', '')
            }
            this.$set(response.data.list[i], 'sort', 'create2' + i)
          }
          this.create.list2 = response.data.list
        } else {
          this.create.list2 = []
        }
        setTimeout(() => {
          this.create.listLoading2 = false
        }, 100)
      })
    },
    changeDriver(item, row) {
      row.driver = this.driverList.find(obj => obj.id == item).drivername
    },
    focusOperatetime(row) {
      console.log(row)
      GetDataByName(this.create.getdataListParm).then(response => {
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            if (response.data.list[i].driver == undefined || response.data.list[i].driverid == undefined) {
              this.$set(response.data.list[i], 'driver', '')
              this.$set(response.data.list[i], 'driverid', '')
            }
            this.$set(response.data.list[i], 'sort', 'create' + i)
          }
          this.create.createList = [...response.data.list]
        } else {
          this.create.createList = []
        }
      })
    },
    changeOperatetime(row) {
      console.log(this.create.createList)
      for (let i = 0; i < this.create.createList.length; i++) {
        if (row.sort == this.create.createList[i].sort) {
          if (new Date(row.operatetime) < new Date(this.create.createList[i].operatetime)) {
            row.operatetime = this.create.createList[i].operatetime
            this.$message({ type: 'error', message: '生效日期不可小于上次日期', duration: 2000 })
          }
        }
      }
    },
    focusOperatetime2(row) {
      console.log(row)
      GetDataByName(this.create.getdataListParm2).then(response => {
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            if (response.data.list[i].driver == undefined || response.data.list[i].driverid == undefined) {
              this.$set(response.data.list[i], 'driver', '')
              this.$set(response.data.list[i], 'driverid', '')
            }
            this.$set(response.data.list[i], 'sort', 'create2' + i)
          }
          this.create.createList2 = [...response.data.list]
        } else {
          this.create.createList2 = []
        }
      })
    },
    changeOperatetime2(row) {
      console.log(this.create.createList2)
      for (let i = 0; i < this.create.createList2.length; i++) {
        if (row.sort == this.create.createList2[i].sort) {
          if (new Date(row.operatetime) < new Date(this.create.createList2[i].operatetime)) {
            row.operatetime = this.create.createList2[i].operatetime
            this.$message({ type: 'error', message: '生效日期不可小于上次日期', duration: 2000 })
          }
        }
      }
    },
    createData() {
      console.log('点击了新增保存', this.create.list)
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)

      for (var i = 0; i < this.create.list.length; i++) {
        if (this.create.list[i].driverid == '') {
          this.create.list.splice(i, 1)
          i = 0
        }
      }
      for(let i=0;i<this.create.list.length;i++){
        if(this.create.list[i].operatetime == '' || this.create.list[i].operatetime == undefined){
          this.$message({ type: 'error', message: '生效日期不可为空', duration: 2000 })
          return
        }
      }
      console.log('点击了新增保存11', this.create.list)
      this.requestParam.common = { 'returnmap': '0' }
      this.requestParam.data = []
      this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.create.list }}
      this.requestParam.data[0].children = []
      this.requestParam.data[0].children[0] = { 'name': 'insertDutyrecord', 'type': 'e', 'parammaps': {
        pastureid: '@insertSpotList.pastureid',
        eqid: '@insertSpotList.eqid',
        eqclass: '@insertSpotList.eqclass',
        eqcode: '@insertSpotList.eqcode',
        driver: '@insertSpotList.driver',
        driverid: '@insertSpotList.driverid',
        times: '@insertSpotList.times',
        operatetime: '@insertSpotList.operatetime',
        emp: Cookies.get('employename')
      }}
      ExecDataByConfig(this.requestParam).then(response => {
        console.log('分配TMR设备保存发送参数', this.requestParam)
        if (response.msg === 'fail') {
          const dutyrecordUniq = new RegExp("key 'dutyrecord-uniq'")
          if (dutyrecordUniq.test(response.data)) {
            this.$message({ type: 'error', message: '当前日期已分配驾驶员不可重复分配', duration: 2000 })
          } else {
            this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
          }
        } else {
          this.$notify({ title: '', message: '保存成功', type: 'success', duration: 2000 })
          this.create.dialogFormVisible = false
          this.getList()
        }
      })
    },
    createData2() {
      console.log('分配铲车', this.create.list2)
      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)

      for (var i = 0; i < this.create.list2.length; i++) {
        if (this.create.list2[i].driverid == '') {
          this.create.list2.splice(i, 1)
          i = 0
        }
      }

      console.log('点击了新增保存', this.create.list)
      this.requestParam.common = { 'returnmap': '0' }
      this.requestParam.data = []
      this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.create.list2 }}
      this.requestParam.data[0].children = []
      this.requestParam.data[0].children[0] = { 'name': 'insertDutyrecord', 'type': 'e', 'parammaps': {
        pastureid: '@insertSpotList.pastureid',
        eqid: '@insertSpotList.eqid',
        eqclass: '@insertSpotList.eqclass',
        eqcode: '@insertSpotList.eqcode',
        driver: '@insertSpotList.driver',
        driverid: '@insertSpotList.driverid',
        times: '@insertSpotList.times',
        operatetime: '@insertSpotList.operatetime',
        emp: Cookies.get('employename')
      }}
      ExecDataByConfig(this.requestParam).then(response => {
        console.log('分配TMR设备保存发送参数', this.requestParam)
        if (response.msg === 'fail') {
          const dutyrecordUniq = new RegExp("key 'dutyrecord-uniq'")
          if (dutyrecordUniq.test(response.data)) {
            this.$message({ type: 'error', message: '当前日期已分配驾驶员不可重复分配', duration: 2000 })
          } else {
            this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
          }
        } else {
          this.$notify({ title: '', message: '保存成功', type: 'success', duration: 2000 })
          this.create.dialogFormVisible = false
          this.getList()
        }
      })
    },

    // 删除
    handleRowDelete(row) {
      console.log('点击了行内删除')
      this.selectList = []
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        this.selectList = []
        this.requestParam.name = 'deleteDutyrecord'
        this.requestParam.parammaps = {}
        this.requestParam.parammaps.pastureid = row.pastureid
        this.requestParam.parammaps.id = row.id
        PostDataByName(this.requestParam).then(response => {
          if (response.msg === 'fail') {
            this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '成功', message: '删除成功', type: 'success', duration: 2000 })
            this.getList()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    },
    handleSelectionChange(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    form_delete() {
      console.log('点击了删除')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择值班记录', duration: 2000 })
      } else {
        MessageBox.confirm('当前选中' + this.selectList.length + '条信息，是否删除?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          console.log(this.selectList)
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.selectList }}
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = { 'name': 'deleteDutyrecord', 'type': 'e', 'parammaps': {
            id: '@insertSpotList.id',
            pastureid: '@insertSpotList.pastureid'
          }}
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('删除保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
              this.getList()
            }
          })
        })
      }
    },

    // 导出
    handleExport() {
      console.log('点击了导出')
      this.download.getdataListParm.parammaps = this.table.getdataListParm.parammaps
      if (this.download.getdataListParm.parammaps.inputDatetime !== '' && this.download.getdataListParm.parammaps.inputDatetime !== null) {
        this.download.getdataListParm.parammaps.startTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.download.getdataListParm.parammaps.stopTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.download.getdataListParm.parammaps.inputDatetime = ''
        this.download.getdataListParm.parammaps.startTime = ''
        this.download.getdataListParm.parammaps.stopTime = ''
      }
      GetDataByName(this.download.getdataListParm).then(response => {
        if (response.data.list !== null) {
          this.download.list = response.data.list
        } else {
          this.download.list = []
        }
        var excelDatas = [
          {
            tHeader: ['生效日期', '班次', '设备类别', '设备编号', '驾驶员', '分配人'],
            filterVal: ['operatetime', 'times', 'eqclass', 'eqcode', 'driver', 'emp'],
            tableDatas: this.download.list,
            sheetName: 'Sheet1'
          }
        ]
        json2excel(excelDatas, '值班记录', true, 'xlsx')
      })
    }

  }
}
</script>
<style lang="scss" scoped>
  /deep/ .operatetime {margin-right: 0;}
</style>
